"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicCallFn = exports.LoadOnMountNoArgs = exports.LoadOnMount = exports.BasicdemoHook = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const use_async_request_1 = require("./use-async-request");
const sleep = (delay) => new Promise((res) => {
    setTimeout(function () {
        res();
    }, delay);
});
const callFn = (arg1) => __awaiter(void 0, void 0, void 0, function* () {
    yield sleep(100);
    return { message: arg1 };
});
const BasicdemoHook = () => {
    const { loading, response, error, reload } = (0, use_async_request_1.useAsyncRequest)({
        args: ['world'],
        callOnInit: false,
        callFn,
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("h1", null, "Output "),
        loading ? 'Loading' : 'Not loading',
        react_1.default.createElement("button", { onClick: () => reload() }, "Call"),
        react_1.default.createElement("p", null, response === null || response === void 0 ? void 0 : response.message)));
};
exports.BasicdemoHook = BasicdemoHook;
const LoadOnMount = () => {
    const callCount = react_1.default.useRef(0);
    const callFn = (arg1) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        callCount.current += 1;
        return { message: arg1 };
    });
    const { loading, response, error, reload } = (0, use_async_request_1.useAsyncRequest)({
        args: ['world'],
        callOnInit: true,
        callFn,
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("h1", null, "Output "),
        loading ? 'Loading' : 'Not loading',
        react_1.default.createElement("button", { onClick: () => reload() }, "Call"),
        react_1.default.createElement("button", { onClick: () => reload(['sun']) }, "Call override"),
        react_1.default.createElement("p", null, response === null || response === void 0 ? void 0 : response.message),
        react_1.default.createElement("p", null,
            "Call count: ",
            callCount.current)));
};
exports.LoadOnMount = LoadOnMount;
exports.LoadOnMount.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () {
    yield react_2.screen.findByText('world');
    yield react_2.screen.findByText('Call count: 1');
});
const LoadOnMountNoArgs = () => {
    const callCount = react_1.default.useRef(0);
    const callFn = (arg1) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        callCount.current += 1;
        return { message: arg1 || "world" };
    });
    const { loading, response, error, reload } = (0, use_async_request_1.useAsyncRequest)({
        callOnInit: true,
        callFn,
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("h1", null, "Output "),
        loading ? 'Loading' : 'Not loading',
        react_1.default.createElement("button", { onClick: () => reload() }, "Call"),
        react_1.default.createElement("button", { onClick: () => reload(['sun']) }, "Call override"),
        react_1.default.createElement("p", null, response === null || response === void 0 ? void 0 : response.message),
        react_1.default.createElement("p", null,
            "Call count: ",
            callCount.current)));
};
exports.LoadOnMountNoArgs = LoadOnMountNoArgs;
exports.LoadOnMountNoArgs.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () {
    yield react_2.screen.findByText('world');
    yield react_2.screen.findByText('Call count: 1');
});
const DynamicCallFn = () => {
    const callFnA = (arg1) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        alert('hello');
        return { message: arg1 };
    });
    const { loading, response, error, reload } = (0, use_async_request_1.useAsyncRequest)({
        args: ['world'],
        callOnInit: false,
        callFn: callFnA,
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("h1", null, "Output "),
        loading ? 'Loading' : 'Not loading',
        react_1.default.createElement("button", { onClick: () => reload() }, "Call"),
        react_1.default.createElement("p", null, response === null || response === void 0 ? void 0 : response.message)));
};
exports.DynamicCallFn = DynamicCallFn;
//# sourceMappingURL=use-async-request.composition.js.map